EDIT - feature request #7148
feature request # 6867 (Closed): explicitely assign and revoke UPDATE & DELETE permission per enitity in the registration workflow

GrantedAuthorityRevokingRegistrationUpdateLister: delete orphan references to
GrantedAuthoritylmpl in User and Group

12/21/2017 02:05 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Priority14 Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 4.13

Severity: major

Description

The GrantedAuthorityRevokingRegistrationUpdateLister deletes GrantedAuthoritylmpl entities but the references to
GrantedAuthoritylmpl in User and Group are not deleted with the entities.

Update of the description with documentation from the GrantedAuthorityRevokingRegistrationUpdateListe.class:

This Hibernate PostUpdateEventListener is responsible for revoking GrantedAuthorities from any user which is having per entity
permissions in the object graph of the Registrationbeing updated This encompasses GrantedAuthotities with the CRUD values
CRUD.UPDATE, CRUD.DELETE. Please refer to the method documentation of collectDeleteCandidates(Registration) for further
details.

The according permissions are revoked when the RegistrationStatus is being changed by a database update. The RegistrationStatus
causing this are contained in the constant MODIFICATION_STOP_STATES which are

® RegistrationStatus.PUBLISHED,
¢ RegistrationStatus.READY,
¢ RegistrationStatus.REJECTED

Related issues:

Related to EDIT - bug #7531: PermissionDeniedException on flushing registrati... Closed
Related to EDIT - bug #7147: GrantedAuthorityRevokingDeleteListener implemented New
Copied to EDIT - task #7274: GrantedAuthorityRevokingRegistrationUpdateLister... Closed

Associated revisions

Revision 414b59c4 - 01/15/2018 04:21 PM - Andreas Kohlbecker
fix #7148 deleteting GrantedAuthoritylmpl and dissociate them from User and Group

History

#1 - 12/21/2017 02:07 PM - Andreas Kohlbecker

Hallo Andreas und Katja,

ich versuche per hql GrantedAuthoritylmpls und die zugehérigen Relationen von User und Group auf die zu I6schenden Entities zu lI6schen.
Hier ist meine Methode

/**
* @param deleteCandidates
=y

private void deleteAuthorities (EventSource session, Set<CdmAuthority> deleteCandidates) {

Collection<String> authorityStrings = new ArrayList<String>(deleteCandidates.size());
deleteCandidates.forEach( dc -> authorityStrings.add(dc.toString()));

String hqgl3 =
"update Group g set g.grantedAuthorities = null where g.grantedAuthorities in (select ga from GrantedAuthority
Impl ga where ga.authority in (:authorities))";

Query query3 = session.createQuery (hgl3);

query3.setParameterList ("authorities", authorityStrings);

query3.setFlushMode (FlushMode .MANUAL) ;
// workaround for HHH-11822 (https://hibernate.atlassian.net/browse/HHH-11822)
query3.executeUpdate () ;

String hqgl2 =

"update User u set u.grantedAuthorities = null where u.grantedAuthorities in (select ga from GrantedAuthorityI
mpl ga where ga.authority in (:authorities))";
Query query2 = session.createQuery (hgl2);

query2.setParameterList ("authorities", authorityStrings);
query?2.setFlushMode (FlushMode .MANUAL) ;

// workaround for HHH-11822 (https://hibernate.atlassian.net/browse/HHH-11822)
query2.executeUpdate () ;

String hgll = "delete from GrantedAuthorityImpl as ga where ga.authority in (:authorities)";
Query queryl = session.createQuery (hqgll);
queryl.setParameterList ("authorities", authorityStrings);
queryl.setFlushMode (FlushMode .MANUAL) ;
// workaround for HHH-11822 (https://hibernate.atlassian.net/browse/HHH-11822)
queryl.executeUpdate () ;
}

Abgesehen davon dass schon die erste hql query probleme bei der Ubersetzung nach MySQL macht:

Caused by: com.mysqgl. jdbc.exceptions. jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax;
check the manual that corresponds to your MySQL server version for the right syntax to use near
'set .=null where . in (select grantedaut5_.id from GrantedAuthorityImpl granteda' at line 1

habe ich ohnehin Zweifel, ob die Delete-Query fir die Foreign keys Ubehaupt funktionieren, da Group.grantedAuthorities und User.grantedAuthorities
nicht null sein darfen.
Allerdings habe ich bisher auch keine andere Mdglichkeit gefunden. Eine altere Syntax wird von Hibernate 5 leider nicht mehr unterstitzt:

Delete g.grantedAuthorities from Group g where

Viele GruB3e
Andreas

#2 - 01/15/2018 10:13 AM - Andreas Kohlbecker

Hallo Andreas,

ist das Problem noch aktuell?
Warum machst Du das delete tber hql queries und nicht tber die persistence Methoden?

Wieso setzt Du denn grantedAuthorities auf null, Du willst Doch nur die eine GrantedAuthority I6schen bzw alle die, die in der Liste enthalten sind,
oder?

Weil wenn grantedAuthorieties nicht null sein darf, dann sollte man ja die Gruppe auch l6schen, wenn es keine grantedAuthorities mehr gibt, oder
bevor die letzte geldscht wird, noch einmal nachfragen, ob die Gruppe auch geléscht werden soll.

Viele Grif3e,
Katja

#3 - 01/15/2018 10:13 AM - Andreas Kohlbecker
Hallo Katja,

das Problem ist noch aktuell.

Warum machst Du das delete Gber hql queries und nicht tber die persistence Methoden?

Diese Methode steckt in einem HibernateEventListener der auf PostUpdateEvents reagiert:
eu.etaxonomy.cdm.persistence.hibernate.GrantedAuthorityRevokingRegistrationUpdateLister in cdm-vaadin

Das heif3t deleteAuthorities() wird in einer Situation aufgerufen in der die Liste der zu prozessierenden Hibernate-Actions schon komplett ist, daher
dachte ich, dass es vermutlich besser ist nicht die Persistence-Methoden zu verwenden, sondern die GrantedAuthorities die per HQL zu l6schen. Es
handelt sich bei diesen GrantedAuthorities um, per-entity permissions, also solche die direkt an User vergeben worden sind. Wenn lediglich ich die
GrantedAuthorities 18sche, bleiben die Eintrage in der m-n-Tabelle UserAccount_GrantedAuthoritylmpl erhalten. Das macht Hibernate leider nicht
automatisch. Sofern das Uber das Cascading oder die ToMany Annotation gelést werden kann wére das auch eine prima Lésung.

Aber vielleicht sollte ich es doch einfach mit den persistence Methoden probieren, eventuell verursacht das gar keine Probleme wenn man diese
innerhalb eines HibernateEventListeners aufruft?

Wieso setzt Du denn grantedAuthorities auf null, Du willst Doch nur die eine GrantedAuthority I6schen bzw alle die, die in der Liste enthalten

sind, oder?

Um die Eintrége in der UserAccount_GrantedAuthoritylmpl tabelle zu I6schen, die tbrig bleiben wirden nach dem die GrantedAuthorities geldscht
sind.

Viele GruB3e
Andreas

#4 - 01/15/2018 10:13 AM - Andreas Kohlbecker
Hallo Andreas,
wir hatten vor Weihnachten da ja schon mal driiber gesprochen. Hier noch ein paar Gedanken.

Dass das null setzen nicht hinhaut, sagst du ja selber. V.a. weil ja nur eine/einige, aber nicht alle granted authorities des Users/der Gruppe geldscht
werden sollen.

Ich habe auch noch mal selber recherchiert und keinen simplen Weg tber HQL gefunden, wie man das machen kann

http://www.codejava.net/frameworks/hibernate/hibernate-basics-3-ways-to-delete-an-entity-from-the-datastore war ganz interessant. Hibernate
scheint sich um FKs wirklich nicht zu scheren.

Mir sieht es so aus als ob es in diesem Fall wirklich am besten ist, die User/Group Instanz zu laden und die authorities per Hand zu entfernen und
dann erst die Authority zu I6schen.

Aber ich misste das auch manuell ausprobieren um sicher zu sein. Katja hat da vielleicht noch mehr Erfahrung mit.

Viele Grif3e,
Andreas M.

#5 - 01/15/2018 10:14 AM - Andreas Kohlbecker
- Priority changed from New to Highest

- Severity changed from normal to critical

#6 - 01/15/2018 10:14 AM - Andreas Kohlbecker
- Priority changed from Highest to Priority14

- Severity changed from critical to major

#7 - 01/15/2018 04:12 PM - Andreas Kohlbecker
- Status changed from New to In Progress

- % Done changed from 0 to 30

ich habe eine Lésung gefunden. Es funkioniert die User Instanzen zu laden um dann die assoziierten GrantedAuthorities zu I16schen. Allerdings muss
man das in einer neuen, also separazen Session tun, ansonsten bekommt man ConcurrentModificationExeptions!

hier der code fiir User:

T
// this needs to be executed in a separate session to avoid concurrent modification problems
Session newSession = session.getSessionFactory () .openSession();

Transaction txState = newSession.beginTransaction();

Query userQuery = newSession.createQuery (
"select u from User u join u.grantedAuthorities ga where ga.authority in (:authorities)");
userQuery.setParameterList ("authorities"™, authorityStrings);
List<User> users = userQuery.list();
for (User user : users) {
List<GrantedAuthority> deleteFromUser = user.getGrantedAuthorities () .stream().filter(
ga —-> authorityStrings.contains (ga.getAuthority())
)
.collect (Collectors.toList ());
user.getGrantedAuthorities () .removeAll (deleteFromUser) ;
}
newSession.flush();
txState.commit () ;
newSession.close () ;

/e

mit den Groups geht das aquivalent

#8 - 01/15/2018 04:21 PM - Andreas Kohlbecker
- Status changed from In Progress to Resolved

- % Done changed from 30 to 50
Applied in changeset cdm-vaadin|414b59c4250183d4331b845c8e4f047661fcc691.

#9 - 01/15/2018 04:23 PM - Andreas Kohlbecker
- % Done changed from 50 to 30

do final review after phycobank playday, by setting all newly created Registrations to the state PUBLISHED and check if all per emtity permissions are
gone.

#10 - 01/18/2018 03:11 PM - Andreas Miiller
Andreas Kohlbecker wrote:
ich habe eine Loésung gefunden. Es funkioniert die User Instanzen zu laden um dann die assoziierten GrantedAuthorities zu I6schen. Allerdings

muss man das in einer neuen, also separazen Session tun, ansonsten bekommt man ConcurrentModificationExeptions!

In welcher Reihenfolge 16scht du denn? Wenn du erst die Relationen 16scht und dann die GrantedAuthority selber, sollte das eigentlich in der gleichen
Session gehen, oder hast du das ausprobiert? Ist auch sauberer.

#11 - 01/18/2018 03:34 PM - Andreas Kohlbecker
Andreas Miller wrote:
Andreas Kohlbecker wrote:
ich habe eine Lésung gefunden. Es funkioniert die User Instanzen zu laden um dann die assoziierten GrantedAuthorities zu l16schen.

Allerdings muss man das in einer neuen, also separazen Session tun, ansonsten bekommt man ConcurrentModificationExeptions!

In welcher Reihenfolge 16scht du denn? Wenn du erst die Relationen 16scht und dann die GrantedAuthority selber, sollte das eigentlich in der
gleichen Session gehen, oder hast du das ausprobiert? Ist auch sauberer.

Nein das geht eben nicht. Zuerst hatte ich das auch so versucht und dann Concurrent-Modification-Probleme bekommen, daher auch der Kommentar
im Kode:

// this needs to be executed in a separate session to avoid concurrent modification problems

#12 - 01/19/2018 04:21 PM - Andreas Miiller

- Assignee changed from Andreas Kohlbecker to Katja Luther

Ja, das hatte ich gesehen, war mir aber nicht sicher, auf welche Stelle des Codes sich das bezog.

Katja, kannst du da mal drauf schauen? Wie I6schen wir denn sonst Objekte aus einer Collection, wenn das Objekt selber auch geléscht werden soll.
Das musste doch eigentlich ein Standard sein.

#13 - 01/19/2018 04:22 PM - Andreas Miiller

... immer 2 Sessions zu 6ffnen, kann da ja eigentlich nicht die Standardlésung sein und klingt auch transaktional unsauber.
#14 - 01/22/2018 10:01 AM - Katja Luther
Andreas Muller wrote:
Ja, das hatte ich gesehen, war mir aber nicht sicher, auf welche Stelle des Codes sich das bezog.
Katja, kannst du da mal drauf schauen? Wie I6schen wir denn sonst Objekte aus einer Collection, wenn das Objekt selber auch geléscht werden
soll. Das miisste doch eigentlich ein Standard sein.
in anderen Fallen entfernen wir das Objekt aus der Collection und rufen danach fur das entfernte Objekt delete auf (siehe z.B. TaxonNodeDao, wenn
auch die Kinder geldscht werden sollen)
for (TaxonNode node:nodes) {
node = HibernateProxyHelper.deproxy (node, TaxonNode.class);
if (node.equals (persistentObject)) {
if (node.hasChildNodes ()) {
Iterator<TaxonNode> childNodes = node.getChildNodes () .iterator();

TaxonNode childNode;
List<TaxonNode> listForDeletion = new ArrayList<TaxonNode> () ;
while (childNodes.hasNext ()) {
childNode = childNodes.next ();
listForDeletion.add (childNode) ;
childNodes.remove () ;

}
for (TaxonNode deleteNode:listForDeletion) {
delete (deleteNode, deleteChildren);

taxon.removeTaxonNode (node, deleteChildren);
taxonDao.saveOrUpdate (taxon) ;
taxon = HibernateProxyHelper.deproxy (taxonDao.findByUuid (taxon.getUuid()), Taxon.class);

taxonDao.delete (taxon) ;

#15 - 01/22/2018 10:04 AM - Katja Luther

Andreas Kohlbecker wrote:
Andreas Miiller wrote:
Andreas Kohlbecker wrote:
ich habe eine Losung gefunden. Es funkioniert die User Instanzen zu laden um dann die assoziierten GrantedAuthorities zu l16schen.

Allerdings muss man das in einer neuen, also separazen Session tun, ansonsten bekommt man ConcurrentModificationExeptions!

In welcher Reihenfolge 16scht du denn? Wenn du erst die Relationen 16scht und dann die GrantedAuthority selber, sollte das eigentlich in
der gleichen Session gehen, oder hast du das ausprobiert? Ist auch sauberer.

Nein das geht eben nicht. Zuerst hatte ich das auch so versucht und dann Concurrent-Modification-Probleme bekommen, daher auch der
Kommentar im Kode:

// this needs to be executed in a separate session to avoid concurrent modification problems

Diese concurrent modification Probleme bekommt man durch das Veréndern der Collection und die muss man umgehen, indem man zweimal eine
Schleife durchlauft, erst einmal alle zu I16schenden Objekte in eine neue Liste und aus der Collection entfernen und danach erst Iéschen.

#16 - 01/22/2018 10:18 AM - Andreas Miiller

Katja Luther wrote:
Andreas Kohlbecker wrote:

Diese concurrent modification Probleme bekommt man durch das Verandern der Collection und die muss man umgehen, indem man zweimal
eine Schleife durchlduft, erst einmal alle zu I6schenden Objekte in eine neue Liste und aus der Collection entfernen und danach erst I6schen.

Why don't you use an iterator. With iterator.remove() you don't get concurrent modification. See Katjas code above.

#17 - 01/22/2018 02:24 PM - Andreas Kohlbecker

Andreas Muller wrote:
Katja Luther wrote:
Andreas Kohlbecker wrote:

Diese concurrent modification Probleme bekommt man durch das Veréndern der Collection und die muss man umgehen, indem man
zweimal eine Schleife durchlauft, erst einmal alle zu I6schenden Objekte in eine neue Liste und aus der Collection entfernen und danach
erst l6schen.

Genau das mach ich doch in meinem code!!!
Die concurrent modification Probleme treten innerhalb von hibernate auf. An der Stelle wo sich der PostUpdateEventListener einklinkt befindet

hibernate sich in Mitten der Bearbeitung der ActionQueue also in org.hibernate.engine.spi.ActionQueue.executeActions() irgendo hier drin tritt die
concurrent modification auf, das lasst sich meines Wissens nur mit einer separaten Session umgehen.
An einer separaten Session kann ich Gbrigens nichts schlechtes erkennen, denn beide Sessions sind transaktional sauber getrennt. Es fehlt eventuell
in meinem Code noch die Fehlerbehandlung fir den Fall dass das der flush oder commit der zweiten Session fehl schlagt.

#18 - 02/16/2018 12:44 PM - Katja Luther
- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Andreas Kohlbecker

do you want to add the exception handling for failing flush or commit?

#19 - 02/16/2018 12:53 PM - Andreas Kohlbecker
- Copied to task #7274: GrantedAuthorityRevokingRegistrationUpdateLister: add the exception handling for failing flush or commit added

#20 - 02/16/2018 12:53 PM - Andreas Kohlbecker
- Category changed from cdm-vaadin to cdmlib

- Status changed from Feedback to Closed

- % Done changed from 30 to 100

remaining task copied to new issue

#21 - 06/28/2018 08:12 AM - Andreas Kohlbecker

- Category changed from cdmlib to cdm-vaadin

#22 - 07/05/2018 02:14 PM - Andreas Kohlbecker

- Related to bug #7531: PermissionDeniedException on flushing registration with modified status even if the user has the required authority added

#23 - 07/05/2018 02:15 PM - Andreas Kohlbecker
- Related to bug #7147: GrantedAuthorityRevokingDeleteListener implemented added

#24 - 07/05/2018 02:31 PM - Andreas Kohlbecker

- Description updated
